/* ordArray.cpp is a program to insert, delete and search an element in
ordered array */

#include <stdio.h>
#include<conio.h>
#define MAXSIZE 100
int bSearch(int[], int,int);
void main()
{
	int ordA[MAXSIZE];
	int sElem, pofElem, dElem,iElem;
	int nElem =0;
	int i,ch;
	int insElem(int[], int, int);
	int delElem(int[], int, int);
	
	void display(int[], int);
	do	{
		printf("\n Enter your choice");
		printf("\n 1. Insert an element  ");
		printf("\n 2. Delete an element ");
		printf("\n 3. Search an element  ");
		printf("\n 4. Display ordered array elements");
		printf("\n 5. Exit \n");
		scanf("%d", &ch);
		fflush(stdin);
		switch (ch)
		{
			case 1:
			   printf("\n Please Enter the element value to be insert: ");
			   scanf("%d", &iElem);
			   nElem =insElem(ordA, nElem, iElem);
			   break;
			case 2:
			   printf("\n Please Enter the element value to be delete: ");
			   scanf("%d", &dElem);
			   nElem =delElem(ordA, nElem,dElem);
			   break;
			case 3:
			   printf("\n Please Enter the element value to be search: ");
			   scanf("%d", &sElem);
			   pofElem = bSearch(ordA, nElem,sElem);
			   printf("\n Element found at location %d", pofElem);
			   break;
			case 4:
			   display(ordA, nElem);

		}			   /* end of switch statement */
	}while (ch!=5);   /* End of do-while loop */
}/* end of main function */

int insElem(int ordA[MAXSIZE], int nElem, int iElem)
{
	int j,k;

	for(j=0;j<nElem;j++)   /* find where it goes using linear search */
	   if (ordA[j] > iElem)
			break;
	for(k=nElem; k>j;k--)  /* moves bigger ones down towards upper bound */
		ordA[k] = ordA[k-1];
	ordA[j] = iElem;	   /* insert it */
	nElem++;               /* increment size */
	return nElem;
} /* end of insElem function */


int delElem(int ordA[MAXSIZE],int nElem, int delElem)
{
	int i,pofElem;

	pofElem = bSearch(ordA, nElem, delElem);
	if (pofElem==-1)
		printf("\n Element can't find, not deleted");
	else
		{
		for(i = pofElem; i<nElem ;i++) /* this for loop shift all the elements
		of the array dice upwards to fill up the gap created by element at
		position pofElem */
		ordA[i] = ordA[i+1];
		nElem--;
		}
	return nElem;
}

/* Function to search an element in the ordered array using binary search */
int bSearch(int ordA[MAXSIZE],int nElem, int sElem)
{
	int low  = 0;
	int high = nElem -1;
	int mid = (low +high)/2;

	while ((low<=high) && (ordA[mid]!=sElem))
	{
		if (sElem < ordA[mid] )
			high = mid -1;
		else
			low = mid +1;
		mid = (low + high)/2;
	}
	if (ordA[mid] == sElem)
		return mid;
	else
		return -1;
} /* end of bSearch function */

void display(int ordA[MAXSIZE], int nElem)
{
	int i;
	for(i=0;i<nElem;i++)
	printf("\nElement %d: %d", i+1,ordA[i]);
}
