/* Sorting a matrix in decending order i.e. two dimensional arrays row wise
The sort is done with the help of bubble sort method*/
/* twodimsr.cpp */

# include<stdio.h>
#include<conio.h>
#define MAXSIZE 10
int i, j;
int mat[MAXSIZE][MAXSIZE];

void display( int, int);
void readmat( int, int);
void sortmat(int, int);

/* Display function */

void display(int row, int col)
{
	for(i = 0; i < row; i++)
	{
		for(j = 0; j < col; j++)
		{
			printf("\t%d", mat[i][j]);
		}
		printf("\n");
	}
}

/* Input function */

void readmat(int row, int col)
{
	for(i = 0 ; i< row; i++)
	{
		for(j = 0 ;  j<col; j++)
		{
			printf("\nInput element for :row %d: column %d: ", i+1, j+1);
			scanf("%d", &mat[i][j]);
		}
	}
}

/* Sorting of a matrix */

void sortmat(int row, int col)
{
	int flag, temp ;
	do
	{
		flag = 1;
		for(i = 0; i < row; i++)
		{
			for(j = 0; j< col ; j++)
			{
				if(mat[i][j] < mat[i][j+1])
				{
					temp = mat[i][j];
					mat[i][j] = mat[i][j+1];
					mat[i][j+1] = temp;
					flag = 0;
				}
			}
		}
		col -= 1;
	} while(flag == 0);
}

/* main function */

void main()
{
	int r,c;
	printf("\n Input number of rows:");
	scanf("%d", &r);
	printf("\n Input number of cols:");
	scanf("%d", &c);

	readmat(r, c);

	printf("\n Entered Matrix is as follows:\n");
	display(r, c);

	printf("\n Sorted row-wise descended Matrix is as follows:\n");
	sortmat(r, c);

	display(r, c);
}
