/* program to perform data structure operations on doubly linked list */
#include<stdio.h>
#include<conio.h>
#include<string.h>
#include<malloc.h>

struct studinfo{
	int marks;
	struct studinfo *next;
	struct studinfo *prev;
	}*start;

void main()
{
int c;
void createlist();
void traverse();
void traverser();
void deletef();
void deletel();
void inserta();
void insertf();
void insertl();
void search();
void insert();
clrscr();
start= NULL;

do {
printf("\n Enter choice for doubly linked list .... ");
printf("\n 1.Insert in List.... ");
printf("\n 2.Traverse ..");
printf("\n 3.Traverse List in reverse ..");
printf("\n 4.Delete first node ..");
printf("\n 5.Delete last node ..");
printf("\n 6.Insert as a first node..");
printf("\n 7.Insert as a last node..");
printf("\n 8.Search node..");
printf("\n 9.Insert a node after node no..");
printf("\n 10.Insert a node after a given node ");
printf("\n 11.Exit from list..");
printf("\n Enter choice for list .... ");
scanf("%d",&c);
switch (c)
{
case 1:
	createlist();
	break;
case 2:
	traverse();
	break;
case 3:
	traverser();
	break;
case 4:
	deletef();
	break;
case 5:
	deletel();
	break;
case 6:
	insertf();
	break;
case 7:
	insertl();
	break;

case 8:
	search();
	break;
case 9:
	inserta();
	break;
case 10:
	insert();
	break;

}
}while (c!=11);
}/* end of main */

/* function createlist, create a doubly linked list until choice is not 'y'*/
void createlist()
{
	struct studinfo *newnode, *ptr;
	char ch;
	do{
	newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
	printf("Entera new number : marks ");
	scanf("%d",&newnode->marks);
	newnode->next =NULL;
	newnode->prev=NULL;
	if (start == NULL)
		start =newnode;
	else
	{
	ptr = start;
	while (ptr->next!=NULL)
		ptr = ptr->next;
	ptr->next = newnode;
	newnode->prev=ptr;
	}
	fflush(stdin);
	printf("do you want to continue (y/n) ");
	scanf("%c",&ch);
 }while( ch =='y' || ch =='Y');
} /* end of function */

/* function traverse, display each node of the list */
void traverse()
{
	struct studinfo *ptr;
	ptr= start;
	while (ptr!=NULL)
	{
	printf("\t %d",ptr->marks);
	ptr = ptr->next;
	}
	getch();
}   /* end of function */

/* function traverser, display each node of the list in reverse*/
void traverser()
{
	struct studinfo *ptr;
	ptr= start;
	while (ptr->next!=NULL)
	ptr = ptr->next;
	while(ptr!=NULL)
	{
	printf("\t%d",ptr->marks);
	ptr=ptr->prev;
	}
}  /* end of function */

/* function deletef, delete the first node of the linked list */
void deletef()
 {
	struct studinfo *ptr;
	if(start==NULL)
	{
		printf("list is empty");
		return;
	}
	ptr=start;
	start=start->next;
	start->prev=NULL;
	free(ptr);
}/* end of function */

/* function deletel, delete the last node of the linked list */
void deletel()
 {
	struct studinfo *ptr,*prevptr;
	ptr=start;
	while(ptr->next!=NULL)
	{
		prevptr=ptr;
		ptr=ptr->next;
	}
   prevptr->next=NULL;
   free(ptr);

}/* end of function */
/* function insertf, insert node as first node in the linked list */
void insertf()
 {
   struct studinfo *newnode, *ptr;
	newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
	printf("Entera new number : marks ");
	scanf("%d",&newnode->marks);
	newnode->next =NULL;
	newnode->prev=NULL;
	newnode->next=start;
	start=newnode;
}/* end of function */

/* function insertl, insert node as last node in the linked list */
void insertl()
{
	struct studinfo *newnode, *ptr;
	newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
	printf("Entera new number : marks ");
	scanf("%d",&newnode->marks);
	newnode->next =NULL;
	newnode->prev=NULL;
	if (start == NULL)
		start =newnode;
	else
	{
	ptr = start;
	while (ptr->next!=NULL)
		ptr = ptr->next;
	ptr->next = newnode;
	newnode->prev=ptr;
	}
}
/* function search the given node in the list */
void search()
 {
	int m;
	struct studinfo *ptr;
	printf("\nenter marks to be search");
	scanf("%d",&m);
	ptr=start;
	while(ptr!=NULL)
	 {
		if(ptr->marks==m)
		 {
			printf("\nfound");
			break;
		 }
		else
			ptr=ptr->next;
	 }
	if(ptr==NULL)
		printf("\n not found");
}/* end of function */

/* function inserta, insert node after a given node number in
the linked list */
void inserta()
  {
	int no,cnt=1;
	struct studinfo *newnode, *ptr;
	printf("insert a node number");
	scanf("%d",&no);
	ptr=start;
	while((no!=cnt) &&(ptr!=NULL))
	 {
		ptr=ptr->next;
		cnt++;
	 }

	newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
	printf("Enter a new number : marks ");
	scanf("%d",&newnode->marks);

	newnode->prev=ptr;
	newnode->next=ptr->next;
	ptr->next->prev= newnode;
	ptr->next = newnode;

}/* end of function */

/* function insert, insert node after a given node (info) in the
 linked list */
void insert()
{
	int no;
	struct studinfo *newnode, *ptr;
	printf("insert a marks of a node after which node to be insert");
	scanf("%d",&no);
	newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
	printf("Enter a new number : marks ");
	scanf("%d",&newnode->marks);

	ptr=start;
	while((ptr!=NULL))
	 {
	 if (ptr->marks == no)
			break;

		ptr=ptr->next;
	 }
	 if (ptr!=NULL)
	 {
	  newnode->prev= ptr;
	  newnode->next = ptr->next;
	  ptr->next->prev = newnode;
	  ptr->next = newnode;
	  }
	  else
		printf(" Node not found,, can not insert");
} /* end of function */
