/* Program mparlist.cpp for multiple-precision Arithmetic. It add two larger
integer of 10's of digit using linked list structure. */
#include<stdio.h>
#include<malloc.h>
#include<math.h>
#include<conio.h>
#define MAX 100000
struct nodetype{
long int info;
struct nodetype *next;
}*sp,*sq,*ss;
long int item=0;
struct nodetype *insmpint(struct nodetype *);
struct nodetype *inslast(struct nodetype *, long int);
struct nodetype *addint(struct nodetype *, struct nodetype *);
void display(struct nodetype *);
void main()
{
	struct nodetype *p, *q;
	clrscr();
	p = sp;
	q = sq;
	sp =insmpint(p);
	sq =insmpint(q);
	ss =addint(sp, sq);
	display(ss);
	getch();
}

/* Function insmpint input multiple precision integers into list */
struct nodetype *insmpint(struct nodetype *ptr)
{
	struct nodetype *nptr=NULL;
	long int temp;
	printf("\n Enter the multiple precision integer[up to 9 digits] ");
	scanf("%ld",&item);
	while(item !=0)
	{
	temp = item %MAX;
	ptr =inslast(ptr, temp);
	if (nptr == NULL)
	    nptr = ptr;
	item = item / MAX;
	}
return(nptr);
}

/* Function inslast inserts the node coeficient at the end of the list */
struct nodetype *inslast(struct nodetype *start, long int s)
{
	struct nodetype *newnode;
	newnode = (struct nodetype *)malloc(sizeof(struct nodetype));
	newnode->info = s ;
	newnode->next =NULL;

	if (start==NULL)
	{
	start= newnode;
	return(start);
	 }
	else
	{
	start->next =newnode;
	return(newnode);
	}
} /* End of function inslast */

/* Function addint adds two multiple precision integers  */
struct nodetype *addint(struct nodetype *sp, struct nodetype *sq)
{
	long int carry, number, total;
	struct nodetype *ptrp, *ptrq,*ptrs;
	ptrp = sp;
	ptrq = sq;
	ptrs = ss;
	carry = 0;
	while ((ptrp != NULL) && (ptrq !=NULL))
	{
	total = ptrp->info + ptrq->info + carry;
	carry = total /MAX;
	ptrs = inslast(ptrs, total%MAX);
	if ((ptrp == sp) && (ptrq ==sq))
		ss = ptrs;
	ptrp = ptrp->next;
	ptrq = ptrq->next;
	}
	if (ptrp !=NULL)
		ptrq = ptrp;
	if (ptrq !=NULL)
	{
	while(ptrq!=NULL)
	{
	total = ptrq->info + carry;
	carry = total / MAX;
	ptrs = inslast(ptrs, total%MAX);
	ptrq = ptrq->next;
	}
	}
if (carry !=0)
	ptrs = inslast(ptrs, carry);
return (ss);
}

void display(struct nodetype *start)
{
long int i=0,sum=0;
struct nodetype *ptr=start;
while(ptr!=NULL)
{
/*printf("\n %ld", ptr->info);*/
sum = sum + ptr->info *pow(MAX,i);
i++;
ptr = ptr->next;
}
printf("\nAddition of two multi precision intgers = %ld", sum);
}
