/* program to perform data structure operations on linear linked list.
The node consists of student record: marks and name */
#include<stdio.h>
#include<conio.h>
#include<string.h>
#include<malloc.h>

struct studinfo{
	int marks;
	char name[10];
	struct studinfo *next;
}*start;
void createlist();
void traverse();
void search();
void insertf();
void insertl();
void deletef();
void deletel();
void inserta();
void insertb();
void deleteno();
void insertion(int);
struct studinfo *findloc(int);

void main()
{
	int c,nn;
		clrscr();
	start = NULL;

	do {
	printf("\n Enter choice for LInk List .... ");
	printf("\n 1. Create Link list.... ");
	printf("\n 2. Insert node as First node.. ");
	printf("\n 3. Delete First node ..");
	printf("\n 4. Delete Last node ..");
	printf("\n 5. Seacrh a node ..");
	printf("\n 6. Insert after node no...");
	printf("\n 7. insert before node no");
	printf("\n 8. Insert node as Last node");
	printf("\n 9. Insert node as node number");
	printf("\n 10. Delete node(given no)");
	printf("\n 11.Traverse List..");
	printf("\n 12.Exit Lists..");
	printf("\n Enter choice for LInk List .... ");
	scanf("%d",&c);
	switch (c)
	{
	case 1:
		createlist();
		break;
	case 2:
		insertf();
		break;
	case 3:
		deletef();
		break;
	case 4:
		deletel();
		break;
	case 5:
		search();
		break;
	case 6:
		inserta();
		break;
	case 7:
		insertb();
		break;
	case 8:
		insertl();
		break;
	case 9:
		printf("\n Enter node number ..");
		scanf("%d",&nn);
		insertion(nn);
		break;

	case 10:
		deleteno();
		break;
	case 11:
		traverse();
		break;
	}
  }while (c!=12);
} /* end of main */

/* function create the linear list until choice is 'n' */
void createlist()
{
struct studinfo *newnode, *ptr;
char ch;
do{
	newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
	printf("\nEnter a new  record : marks and name ");
	scanf("%d%s",&newnode->marks,newnode->name);
	newnode->next=NULL;
	if (start == NULL)
		start =newnode;
	else
	{
		ptr =start;
		while (ptr->next != NULL)
			ptr= ptr->next;
		ptr->next = newnode;
	  }
	fflush(stdin);
	printf("do you want to continue (y/n) ");
	scanf("%c",&ch);
 }while( ch =='y' || ch =='Y');
} /* end of function */

/* function search the node in the list in sequential manner */
void search()
{
struct studinfo *ptr;
	char str[10];
	printf("enter name to be searched ");
	scanf("%s",str);
	ptr=start;
	while(ptr!=NULL)
	 {
		if(strcmp(ptr->name,str)==0)
		 {
			printf("\nfound");
			break;
		 }
		else
			ptr=ptr->next;
	 }
	if(ptr==NULL)
		printf("\nnot found");
getch();
}/* end of function */
/* Function insertf, insert node as first node in the linked list */
void insertf()
 {
	struct studinfo  *newnode;
	newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
	printf("\nEnter a new  record : marks and name ");
	scanf("%d%s",&newnode->marks,newnode->name);
	newnode->next=NULL;

	if(start==NULL)
			start = newnode;
		else
	  {
		 newnode->next = start;
		  start = newnode;
	  }
}/* end of function */
/* Function insertl, insert node as last node in the linked list */
void insertl()
{
struct studinfo *newnode, *ptr;
newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
printf("\nEnter a new  record : marks and name ");
scanf("%d%s",&newnode->marks,newnode->name);
newnode->next=NULL;
if (start == NULL)
		start =newnode;
else
	{
	ptr =start;
	while (ptr->next != NULL)
			ptr= ptr->next;
	ptr->next = newnode;
	  }
}/* end of function */

/* Function deletef, delete node as first node in the linked list */
void deletef()
{
   struct studinfo *ptr;
   if (start == NULL)
	{
	printf("\n List is empty");
	return;
	}
   ptr=start;
   start=start->next;
   free(ptr);
} /* end of function*/

/* Function deletel, delete node as last node in the linked list */
void deletel()
  {
	struct studinfo *ptr,*prevptr;
	ptr=start;
	if (ptr->next==NULL)
	      start = NULL;
	else
	{
	while(ptr->next!=NULL)
	 {
		prevptr=ptr;
		ptr=ptr->next;
	 }
	 prevptr->next =NULL;
	 }
	 free(ptr);

}/* end of function */

/* Function inserta, insert node after a given node in the linked list */
void inserta()
{
   int cnt=1, no;
	struct studinfo *ptr,*prevptr, *newnode;
	 printf("\nEnter number ...");
	 scanf("%d",&no);
	 ptr=start;
	 while (cnt != no)
	 {
	 ptr = ptr->next;
	 cnt++;
	 }
	newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
	printf("\nEnter a new  record : marks and name ");
	scanf("%d%s",&newnode->marks,newnode->name);
	newnode->next =NULL;
	 newnode->next = ptr->next;
	 ptr->next = newnode;

}/* end of function */
/* Function insertb, insert node before a given node in the linked list */
void insertb()
 {

	int cnt=1, no;
	struct studinfo *ptr,*prevptr, *newnode;
	 printf("\nEnter number ...");
	 scanf("%d",&no);
	 ptr=start;
	if(no==1)
	 {
		insertf();
	 }
	 else
	 {
		while(cnt !=no)
		 {
			prevptr=ptr;
			ptr = ptr->next;
			cnt++;
		 }
	 newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
	 printf("\nEnter a new  record : marks and name ");
	 scanf("%d%s",&newnode->marks,newnode->name);
	 newnode->next=ptr;
	 prevptr->next=newnode;
	 }
}/* end of function */

void insertion(int nodenum)
{
	struct studinfo *newnode, *loc;
	newnode = (struct studinfo *)malloc(sizeof(struct studinfo));
	printf("\nEnter a new  record : marks and name ");
	scanf("%d%s",&newnode->marks,newnode->name);
	loc = findloc(nodenum);
	if (loc ==NULL)
	{
	newnode->next = start;
	start = newnode;
	}
	else
	{
	newnode->next = loc->next;
	loc->next = newnode;
	}
}/* end of the function*/

struct studinfo *findloc(int nodenum)
{
struct studinfo *prevptr, *ptr;
int cnt=0;
if (nodenum ==1)
   return (NULL);
prevptr =start;
ptr 	=start->next;
while (ptr!=NULL)
{
if ((cnt+1) == nodenum-1)
	return (prevptr);
else
	{
	prevptr =ptr;
	ptr = ptr->next;
	cnt = cnt +1;
	}
}
return (prevptr);
}/* end of function */


/* Function deleteno, delete node by node number in the linked list */
void deleteno()
  {
	 int cnt=1,no;
	 struct studinfo *ptr,*prevptr, *newnode;
	 printf("\nEnter number ...");
	 scanf("%d",&no);
	if(no==1)
	 {
		deletef();
	 }
	else
	{
	ptr=start;

	while(cnt!=no)
		 {
			prevptr=ptr;
			ptr=ptr->next;
			cnt++;
		}
	if (ptr->next == NULL)
	    {
		 deletel();
		 return ;
	    }
	   prevptr->next=ptr->next;
	   free(ptr);
	}
}/* end of function */

/* function travese the each node of the linked list */
void traverse()
{
struct studinfo *ptr;
if (start == NULL)
	{
	printf("\n List is empty");
	return;
	}
ptr= start;
while (ptr !=NULL)
{
printf("\nRecord: marks and name %d  %s\n",ptr->marks, ptr->name);
ptr = ptr->next;
}
getch();
}

