/* Program pqueuell.cpp to implement priority queue operation using linked list.
 Each element has been assigned a priority  in such a way (i) An element of
 higher priority is processed before any element of lower priority.  */

#include<stdio.h>
#include<conio.h>
#include<string.h>
#include<malloc.h>
struct queue{
int items;
int prt;
struct queue *next;
}*rear,*front,*newnode;
struct queue *findloc(int );
void main()
{
int c, item=0, prtitem=0;
void insertion(int, int);
void display();
void deletion();
clrscr();
front=rear= NULL;

do {
printf("\n Enter choice for Priority Queue .... ");
printf("\n 1. Insert in Queue.... ");
printf("\n 2. Delete in Queue..");
printf("\n 3. Display Queue..");
printf("\n 4. Exit from Queue..");
printf("\n Enter choice for Priority Queue .... ");
scanf("%d",&c);
switch (c)
{
case 1:
	printf("Enter the process number and priority number and type -1 for 	termination\n");
	scanf("%d%d",&item,&prtitem);
	if (item != -1)
	  insertion(item, prtitem);
	break;
case 2:
	deletion();
	break;
case 3:
	display();
	break;
}
}while (c!=4);
} /* end of main */

void insertion(int insitem, int prtitem)
{
	struct queue *loc;
	newnode = (struct queue *)malloc(sizeof(struct queue));
	newnode->items = insitem;
	newnode->prt  = prtitem;
	newnode->next = NULL;

	if (front == NULL)
	{
	rear =newnode;
	front = newnode;
	}
	else
	{
	loc = findloc(prtitem);

	if (loc == NULL)
	{
	newnode->next = front;
	front = newnode;
	}
	else
	{
	newnode->next = loc->next;
	loc->next = newnode;
	}
	}
}/* end of the function*/

/*function findloc searches the node position in queue */
struct queue *findloc(int prtitem)
{
	struct queue *prevptr, *ptr;
	if (front ==NULL)
	   return (NULL);
	if (prtitem<front->prt)
		return (NULL);
	prevptr =front;
	ptr 	=front->next;
	while (ptr!=NULL)
	{
	if (prtitem < ptr->prt)
		return (prevptr);
	prevptr =ptr;
	ptr = ptr->next;
	}
 return (prevptr);
} /* end of findloc function */

void display()
{
struct queue *ptr;
ptr= front;
printf("\n Process number process priority \n");
while (ptr !=NULL)
{
printf(" %d \t\t %d \n",ptr->items, ptr->prt);
ptr = ptr->next;
}
getch();
} /* end of display function */

void deletion()
 {
   struct queue *ptr;
   if (front == NULL)
		{
		printf("\n Queue is empty ");
		return ;
		}
   ptr=front;
   front=front->next;
   free(ptr);
 } /* end of deletion function */


