/* Program queue.cpp perform insertion, deletion operation on a
queue which is implmented using array in structure. */

#include<stdio.h>
#define MAXSIZE 5
struct queue{
	int items[MAXSIZE];
	int rear;
	int front;
}q;
void queueins(struct queue *,int);
int  queuedel(struct queue *);
void display(struct queue *);

void queueins(struct queue *q ,int x)
{
/*check for queue full,if so give a warning message and return */

if (q->rear==MAXSIZE -1)
 {
  printf("Queue full\n");
  return;
 }
else
{
/* check for queue empty, if so initialized front and rear pointer to zero.
 Otherwise increment rear pointer*/
 if (q->front == -1)
 { q->front =0; q->rear = 0;}
 else
   q->rear = q->rear+1 ;
 q->items[q->rear] = x;
}
} /* End of queueins function */


int queuedel(struct queue *q)
 {
 int x;
/*check for queue empty, if so raise a warning message and return*/

 if (q->front==-1)
	 printf(" Queue is empty\n");
 x = q->items[q->front];

/* if both pointer at the same position then reset the queue to empty position  otherwise increment front pointer by 1.*/

 if (q->front == q->rear)
 { q->front = -1; q->rear =-1;}
 else
   q->front = q->front +1 ;
return x;

}

void display(struct queue *q)
 {
 int i;
 if (q->front != -1)
  if (q->front <= q->rear)
   for( i=q->front;i<=q->rear;i++)
	printf("%d      ",q->items[i]);
} /* end of display function */


void main()
 {
	int ch,t;
	q.rear = -1;
	q.front = -1; /* Intially queue is empty */

	do{
	printf("\n Operations on Linear Queue ");
	printf(" \n 1. Insert \n 2. Delete\n 3. Display \n 4. Exit:\n");
	printf("\n Select operation ");
	scanf("%d",&ch);
	switch(ch)
	{
	 case 1:
		 printf("\nEnter data ");
		 scanf("%d",&t);
		 queueins(&q,t);
		 break;
	 case 2:
		 queuedel(&q);
		 break;
	 case 3:
		 display(&q);
		 break;
	 case 4:break;
	   }
  }while(ch<4);

} /* end of main */
