/* Program hashscr.c implement the  collision resolution with separate
chaining the help of linked list. The function createlist create MAXSIZE
number of separate buckets using division method hash function*/

#include<stdio.h>
#include<malloc.h>
#include<conio.h>
#define MAXSIZE 10
struct chain{
	int key;
	struct chain *next;
}*ptr,*bucket[MAXSIZE],*newnode;

int item=0;
void createlist(struct chain *bucket[MAXSIZE]);
void display(struct chain *bucket[MAXSIZE]);

void main()
{
	int ch,i,blk;
	for(i=0;i<MAXSIZE;i++)
		bucket[i] = NULL;	/* Initially list is empty */
	createlist(bucket);
	display(bucket);
	getch();
}/* end of main function */

void createlist(struct chain *bucket[MAXSIZE])
{
int h;
	printf("Enter keys and type -1 for termination\n");
	while(item!=-1)
	{
		scanf("%d",&item);
		if (item != -1)
		{
		   h = item % MAXSIZE;
		   if (bucket[h]==NULL)
			{
			ptr = (struct chain *)malloc(sizeof(struct chain));
			bucket[h]=ptr;  /* bucket[h] now points to the first node
							of the list*/
			ptr->key=item;
			ptr->next=NULL;
			}
			 else
			{
			ptr = bucket[h];
			while(ptr->next!=NULL)
				ptr = ptr->next;
			newnode = (struct chain *)malloc(sizeof(struct chain));
			newnode->key = item;
			newnode->next =NULL;
			ptr->next =newnode;
			} /* End of Else structure */
		   } /* End of If structure */
	} /* end of outer while */
} /* End of function createlist */

void display(struct chain *bucket[MAXSIZE])
{
 int i;
 printf("\n List of keys with separate chaining");
 for(i=0;i<MAXSIZE;i++)
 {
	ptr=bucket[i];
	if (ptr)
		printf("\n List of keys in bucket %d-> ",i);
	else
		printf("\n Bucket %d is Empty",i);
	while(ptr!=NULL)
	{
		printf(" %d ", ptr->key);
		ptr = ptr->next;
	}
 }
}

