/* Program heap_t_d.c is heap sort using top down heap construction method */
#include<conio.h>
#include<stdio.h>
void insert(int a[],int n)
{
int i=n,item=a[n];

while((i>1) && (a[i/2]<item))
{
	a[i]=a[i/2];
	i=i/2;
}

a[i]=item;
}

void adjust(int a[],int i,int n)
{
int j=2*i,item=a[i];

while(j<=n)
{
	if((j<n) && (a[j]<a[j+1]))
		j=j+1;

	if(item>=a[j])
		break;

	a[j/2]=a[j];
	j=2*j;
}
a[j/2]=item;
}


void delmax(int a[],int n)
{
int x;

x=a[1],a[1]=a[n];
a[n]=x;
adjust(a,1,n-1);
//return x;
}

void hsorttd(int a[],int n)
{
int i;

for (i=1;i<=n;i++)
	insert(a,i);

for(i=n;i>0;i--)
	delmax(a,i);
}


void main()
{
int x[10],n,i;

clrscr();

printf("Enter the number of elements: ");
scanf("%d",&n);

printf("\nEnter the elements: \n");
for(i=1;i<=n;i++)
scanf("%d",&x[i]);

hsorttd(x,n);

printf("\nThe sorted output:\n");
for(i=1;i<=n;i++)
printf("\n%d",x[i]);

getch();
}
