/* Mergesort describe the sorting process using recursion, which merge
   two sorted sets. The elements set is divided into recursively half of
   the set size repeatedly and then merge. */

#include<stdio.h>
#define MAXSIZE 10

/* Mergesort funtion divide the set size into half of size recursively
then call merge function */
void mergesort(int low ,int high,int a[8])
{
void merge(int,int,int,int[]);
int mid;
if (low < high)
{
	mid = (low+high)/2;
	mergesort(low,mid,a);
	mergesort(mid+1,high,a);
	merge(low,mid,high,a);
	return;
}
} /* End of mergesort function */

/* Merge function merge the two sorted sets , one set is low to mid  and
second set is mid+1 to high */
void merge(int low,int mid,int high,int a[])
{
	int h,b[MAXSIZE],i,j,k;
	h=low;i=low;j=mid+1;
	printf("\n Recursion calls :%d %d %d",low,mid,high);
	while((h<=mid) && (j<=high))
	{
		if (a[h]<= a[j])
			{ b[i]=a[h]; h=h+1; }
		else
			{ b[i]=a[j]; j=j+1; }
		i=i+1;
	}
	if (h>mid)
	   for(k=j;k<=high;k++)
		 { b[i] = a[k]; i=i+1; }
	else
	   for(k=h;k<=mid;k++)
		 { b[i] = a[k]; i=i+1; }
	for (k=low;k<=high;k++)
		a[k]=b[k];
return;
} /* End of merge function */
void main()
{
int a[MAXSIZE],i,j,k,low=0,high,mid,n;
void mergesort(int,int,int[]);
printf("\nEnter the number of elements to be sorted \n");
scanf("%d",&n);
printf(" Enter usorted list elements \n");
for(i=0;i<n;i++)
 {
  printf("\n Enter elment %d", i+1);
  scanf("%d",&a[i]);
 }
high = n-1;
mergesort(low,high,a);
printf("The merge output is ...\n");
for(i=0;i<n;i++)
  printf("\t %d",a[i]);
} /* End of main function */
