
/* Create Binary TREE  and Find height of the tree, and search the tree*/
/* Bstreeop.cpp perform various operations such as insert, delete, search
find height of tree, and tree traversals */

# include<stdio.h>
# include<malloc.h>
#include<conio.h>
struct nodetype
{
	int info;
	struct nodetype *lchild;
	struct nodetype *rchild;
}*root,*dnode, *pardnode; ;
;
int k=0, m=0;
void btreeins(int);
void btsrch(struct nodetype *, int );
void display(struct nodetype *, int);
void inorder(struct nodetype *);
void postorder(struct nodetype *);
void preorder(struct nodetype *);
void btsrchn(int);
void delcaseA(struct nodetype *,struct nodetype *);
void delcaseB();
void btreedel(int);

int height(struct nodetype *,int);
void main()
{
int n=0,ch,x, dn;
clrscr();
root = NULL; /* empty tree */
do{

printf("\n\n Enter choice for tree");
printf("\n 1.Create tree / Insertion");
printf("\n 2.Display tree");
printf("\n 3.Height of tree");
printf("\n 4.Search the desired value");
printf("\n 5.Inorder traversing of tree is");
printf("\n 6.Postorder traversing of tree is");
printf("\n 7.Preorder traversing of tree is");
printf("\n 8. Deletion");
printf("\n 9 Exit");
printf("\n Enter choice for tree operation ");
scanf("%d",&ch);

switch(ch)
{
  case 1:
	while(n!=-1)
	{
		printf("\n Enter node type(-1) to terminate ");
		scanf("%d",&n);
		if (n!=-1)
		  btreeins(n);
	}
	n=0;
	break;
  case 2:
		display(root,0);
		break;
  case 3:
		printf("\n height is %d ",height(root,0));
		break;
  case 4:
		printf("\n  Enter node to be search ");
		scanf("%d",&x);
		btsrch(root,x );
		break;
   case 5:
		inorder(root);
		break;
   case 6:
		postorder(root);
		break;
   case 7:
		preorder(root);
		break;
   case 8: 	printf("\n Enter the node to be delete ");
		scanf("%d",&dn);
		btreedel(dn);
		printf("\n Binary Search Tree after Deletion of node %d is as follows",dn);
		display(root,1);
		break;
   default:     printf("\n Wrong choice !");
	     }
	}while(ch!=9);

} /* end of the main function */

/* The function btreeins insert a node value x in the binary tree */
void btreeins(int x)
{
struct nodetype *p, *parent;
int found =0;
p = root;
while((p!=NULL) &&(!found))
{
 parent = p;
 if (x == p->info)
	found = 1;
 else if (x < p->info )
	p = p->lchild;
 else
	p = p->rchild;
}
if (!found)
{
p = (struct nodetype *)malloc(sizeof(struct nodetype));p->info =x;
p->lchild =NULL;
p->rchild =NULL;

if (root!=NULL)
	{
	if ( x<parent->info)
		parent->lchild =p;
	else
		parent->rchild =p;
	}
else
	root = p;
}
} /* End of function btreeins */

/* The btsrch function find the given node in the binary tree */
void btsrch(struct nodetype *p, int x)
{
 while((p!=NULL) &&(p->info !=x))
 {
 if (p->info >x)
	p = p->lchild;
 else
	p =p->rchild;
 }
if (p==NULL)
  printf("\n Search unsuccessful");
else
  printf("\n Search successful at node address %d",p);
}

/* The height function return the height of the binary tree */
int height(struct nodetype *btreeh, int level)
{
if (btreeh)
{
	height(btreeh->lchild, level+1);
	height(btreeh->rchild, level+1);
}
if ( level> m)
	m = level;

return (m-1);
}

void inorder(struct nodetype *bt)
{
if (bt)
{
	inorder(bt->lchild);
	printf("  %d ",bt->info);
	inorder(bt->rchild);
}
}

void preorder(struct nodetype *bt)
{
if (bt)
{
	printf("  %d ",bt->info);
	preorder(bt->lchild);
	preorder(bt->rchild);
}
}
/* function postorder traverse binary tree post-order sequence */
void postorder(struct nodetype *bt)
{
if (bt)
{
	postorder(bt->lchild);
	postorder(bt->rchild);
	printf("  %d ",bt->info);
}
}


/* Display function display the binary tree in tree forms */

/* The function btreedel delete a node from binary search tree */
void btreedel(int x)
{
btsrchn(x);
if(dnode==NULL)
	{
	printf("\n not found");
	return;
	}
if ((dnode->rchild !=NULL) && (dnode->lchild!=NULL))
	delcaseB();
else
   delcaseA(dnode, pardnode);
free(dnode);
} /* End of function btreedel */

/* The btsrch function search a node in the Binary Search Tree */
void btsrchn(int x)
{
dnode =root;
 while((dnode!=NULL) &&(dnode->info !=x))
 {
 pardnode = dnode;
 if (dnode->info >x)
	dnode = dnode->lchild;
 else
	 dnode = dnode->rchild;
 }
} /* End of function btsrch */

/* The delcaseA function deletes the node with one child or as leaf node */
void delcaseA(struct nodetype *dnode,struct nodetype *pardnode)
{
struct nodetype *child;
if ((dnode->lchild ==NULL) &&(dnode->rchild==NULL))
	child = NULL;
else if ((dnode->lchild)!=NULL)
		child = dnode->lchild;
	else
		child = dnode->rchild;
if (pardnode !=NULL)
	if (dnode==pardnode->lchild)
			pardnode->lchild = child;
	else
		pardnode->rchild = child;
else
		root = child;
}/* End of delcaseA function */

/* The delcaseB function deletes the node with two child  */
void delcaseB()
{
struct nodetype *p,*q, *succ, *parsucc;
p = dnode->rchild;
q = dnode;
while ((p->lchild) !=NULL)
{
	q = p;
	p = p->lchild;
}
succ = p;
parsucc = q;
delcaseA(succ, parsucc);

if (pardnode !=NULL)
	if (dnode == pardnode->lchild)
		pardnode->lchild = succ;
	else
	pardnode->rchild = succ;
else
	root = succ;
succ->lchild = dnode->lchild;
succ->rchild = dnode->rchild;
}/* End of delcaseB function */

void display(struct nodetype *start, int t)
{
int i=1;
struct nodetype *ptr=start;
if (ptr)
{
display (ptr->rchild,t+1);
printf("\n");
for(i=0;i<=t;i++)
	printf("   ");

printf("%d<",ptr->info);
display (ptr->lchild, t+1);
}
}
