/* Program dfs.cpp is depth first search traversal for any graph whose input
is in the form of adjacency matrix and its uses stack operation for non-
recursive implementation */

# include<stdio.h>
# include<conio.h>
#define MAXSIZE 10
#define TRUE 1
#define FALSE 0
int pop(struct stack *);
void push(struct stack *, int);
int empty(struct stack *);
struct stack{
	int top;
	int items[MAXSIZE];
}s;
void adjmat(int[MAXSIZE][MAXSIZE], int);
void dfs(int[MAXSIZE][MAXSIZE],int,int);
void main()
{
	int  a[MAXSIZE][MAXSIZE], v,g;
	s.top =-1;     /* Initialize stack to empty */
	printf("Enter number of vertices in graph\n");
	scanf("%d",&v);
	adjmat(a,v);
	printf("Enter start vertex [0-%d]\n",v-1);
	scanf("%d",&g);
	dfs(a,g,v );
	getch();
} /* end of main */

/* Input function */
void adjmat(int a[MAXSIZE][MAXSIZE], int n)
{
	int i, j;
	printf("\n Input adjacency matrix of order %dx%d\n",n,n);
	for(i =0; i < n; i++)
		for(j =0; j < n; j++)
			scanf("%d", &a[i][j]);
}

void dfs(int a[MAXSIZE][MAXSIZE], int g, int n)
{
	int i,j, visited[MAXSIZE],h;
	for(i=0;i<n;i++)
	visited[i] =0;
	h = g ;
	visited[h] = 1;
	printf("\n DFS sequence with start vertex is -> ");
	while(1)
	{
	printf(" %d ", h);
	 for (j = 0; j<n; j++)
	  {
		if ((a[h][j] == 1) && (visited[j] == 0))
			{
				push(&s, j);
				visited[j] = 1;
			}
	 }
		if (empty(&s))
			return;
		else
			h = pop(&s);

	} /* end of while */
} /* end DFS */





/* function push the integer element into stack s */
void push(struct stack *s, int d)
{
	if (s->top == MAXSIZE -1)
	{
		printf("%s", "stack overflow");
		return;
	}
	else
		s->items[++(s->top)] = d;
	return;
} /* end of push function */

/* function pop the integer element from stack s */
int pop(struct stack *s)
{
	if (empty(s))
	{
		printf("\n%s", "stack underflow");
		return;
	}
	return(s->items[s->top--]);
} /* end of pop function */

int empty(struct stack *s)
{
	if (s->top == -1)
	  return (TRUE);
	else
	 return (FALSE);
} /*end of empty function */

