/* Program kruskal.cpp implement the kruskal's algorithm for computing
minimum cost spanning tree. */
#include<conio.h>
#include<stdio.h>



void adjust(int a[],int i,int n)
{
int j=2*i,item=a[i];

while(j<=n)
{
	if((j<n) && (a[j]<a[j+1]))
		j=j+1;

	if(item>=a[j])
		break;

	a[j/2]=a[j];
	j=2*j;
}
a[j/2]=item;
}


void heapify(int x[],int n)
{
int i;

for(i=n/2;i>0;i--)
	adjust(x,i,n);
}

void hsortbu(int a[],int n)
{
int i,t;

heapify(a,n);

for(i=n;i>1;i--)
{
	t=a[i];
	a[i]=a[1];
	a[1]=t;
	adjust(a,1,--n);
}
}



void main()
{
int x[10],n,i;

clrscr();

printf("Enter the number of elements: ");
scanf("%d",&n);

printf("\nEnter the elements: \n");
for(i=1;i<=n;i++)
scanf("%d",&x[i]);

hsortbu(x,n);

printf("\nThe sorted output:\n");
for(i=1;i<=n;i++)
printf("\n%d",x[i]);

getch();
}
