/* Program to multiply two sparse matrices */
#include<stdio.h>
#include<conio.h>
void CreateSparse(int sparse[][3],int row,int col,int elements);
void showsparseMatrix(int sparse[][3]);
void sparsematrixmultiplication(int sparse1[][3],int sparse2[][3],int sparse3[][3]);
int getelement(int sparse[][3],int row,int col);;
/* main function starts here*/
void main()
{
	int i,j,n,m;
	int sparse1[50][3];
	int sparse2[50][3];
	int sparse3[50][3];
	int colarray[50];
	int elements1,elements2;
	clrscr();
	printf("************************************************************\n");
	printf("THIS IS A PROGRAM TO IMPLEMENT SPARSE MATRIX MULTIPLICATION\n");
	printf("************************************************************\n\n");
	printf("ENTER ROWS AND COLUMNS OF FIRST SPARSE MATRIX :");
	scanf("%d%d",&i,&j);
	printf("\n");
	printf("ENTER ROWS AND COLUMNS OF SECOND SPARSE MATRIX :");
	scanf("%d%d",&n,&m);
	printf("\n");
	clrscr();
	if(j!=n)
	{
		clrscr();
		printf("ERROR :\n");
		printf("COLUMNS OF FIRST MATRIX SHOULD BE EQUAL TO\n");
		printf(" ROWS OF SECOND MATRIX\n");
		printf("Press any key to exit...");
		getch();
		return;
	}
	printf("Enter total Number of Non-Zero elements in first matrix :");
	scanf("%d",&elements1);
	printf("\n");
	printf("Enter total Number of Non-Zero elements in Second matrix :");
	scanf("%d",&elements2);
	printf("\n");

	CreateSparse(sparse1,i,j,elements1);
	CreateSparse(sparse2,n,m,elements2);
	clrscr();

	showsparseMatrix(sparse1);
	showsparseMatrix(sparse2);
	getch();
	sparsematrixmultiplication(sparse1,sparse2,sparse3);
	printf("\nTHIS IS THE RESULTENT SPARSE MATRIX:\n");
	showsparseMatrix(sparse3);
	getch();

}/* void main() ends here*/


 /* Module for creation of sparse matrix */
void CreateSparse(int sparse[][3],int row,int col,int elements)
{
	int i,j;
	/* storing triplets first row*/
	sparse[0][0]=row;
	sparse[0][1]=col;
	sparse[0][2]=elements;
	for(i=1;i<=sparse[0][0];i++)
	{
		sparse[i][0]=0;
		sparse[i][1]=0;
		sparse[i][2]=0;
	}
	printf("Enter %d elements of %dX%d Sparse Matrix one-byone",elements,row,col);
	for(i=1;i<=elements;i++)
       {
		printf("\nEnter row:");
		scanf("%d",&sparse[i][0]);
		printf("\nEnter column:");
		scanf("%d",&sparse[i][1]);
		printf("\nEnter element:");
		scanf("%d",&sparse[i][2]);
       }
}


/*Display the contents of sparse Matrix*/
void showsparseMatrix(int sparse[][3])
{
	int i,j,element;
	printf("\nThis is the %dx%d Sparse Matrix:\n",sparse[0][0],sparse[0][1]);
	for(i=1;i<=sparse[0][0];i++)
	{
		for(j=1;j<=sparse[0][1];j++)
		{
			element=getelement(sparse,i,j);
			printf(" %4d",element);
		}
		printf("\n");
	}
}



//MODULE TO GET A PERTICULAR ELEMENT OF A SPARSE MATRIX
int getelement(int sparse[][3],int row,int col)
{
	int i,j;
	for(i=1;i<=sparse[0][0];i++)
	{
		if(row==sparse[i][0])
		{

				if(col==sparse[i][1])
				return (sparse[i][2]);
		}
	}
	return (0);
}

//MODULE TO MULTIPLICAT TWO SPARSE MATRICES
void sparsematrixmultiplication(int sparse1[][3],int sparse2[][3],int sparse3[][3])
{
	int i,j,k;
	int temp=0;
	int non_zero=0;
	for(i=1;i<=sparse1[0][0];i++)
	{
		sparse3[i][0]=0;
		sparse3[i][1]=0;
		sparse3[i][2]=0;
	}

	for(i=1;i<=sparse1[0][0];i++)
	{
		for(k=1;k<=sparse2[0][1];k++)
		{
			temp=0;
			for(j=1;j<=sparse1[0][1];j++)
			{
			temp+=(getelement(sparse1,i,j) * getelement(sparse2,j,k));
			}
			if(temp!=0)
			{
			  non_zero++;
			  sparse3[i][0]=i;
			  sparse3[i][1]=k;
			  sparse3[i][2]=temp;
			}


		}
	}

	sparse3[0][0]=sparse1[0][0];
	sparse3[0][1]=sparse2[0][1];
	sparse3[0][2]=non_zero;

}