/* Program to perform data structures operation on circular linear linked
list. The node consists of a student record: marks and name */

#include<stdio.h>
#include<conio.h>
#include<string.h>
#include<malloc.h>

struct studinfo{
	int marks;
	char name[10];
struct studinfo *next;
}*start;

void main()
{
int c;
void createlist();
void traverse();
void search();
void insertf();
void insertl();
void deletef();
void deletel();
void inserta();
void insertb();
void deleteno();
clrscr();
start = NULL;

do {
clrscr();
printf("\n Enter choice for Cirqular LInk List .... ");
printf("\n 1. Create Circular Link list.... ");
printf("\n 2. Insert node as First node.. ");
printf("\n 3. Insert node as Last node.. ");
printf("\n 4. Insert after node no...");
printf("\n 5. Insert before node no");
printf("\n 6. Delete First node ..");
printf("\n 7. Delete Last node ..");
printf("\n 8. Delete node(given no)");
printf("\n 9. Seacrh a node ..");
printf("\n 10. Traverse Lists..");
printf("\n 11. Exit Lists..");
printf("\n Enter choice for LInk List .... ");
fflush(stdin);
scanf("%d",&c);
switch (c)
{
case 1:
	createlist();
	break;
case 2:
	insertf();
	break;
case 3:
	insertl();
	break;
case 4:
	inserta();
	break;

case 5:
	insertb();
	break;

case 6:
	deletef();
	break;
case 7:
	deletel();
	break;
case 8:
	deleteno();
	break;

case 9:
	search();
	break;

case 10:
	traverse();
	break;
}
}while (c!=11);
}

/* function to create circular linear linked list */
void createlist()
{
	struct studinfo *newnode, *ptr;
	char ch;
	do{
	newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
	printf("Enter a new record : marks and name ");
	scanf("%d%s",&newnode->marks,newnode->name);
	if (start == NULL)
	{
		start =newnode;
		newnode->next = newnode;
	}
	else
	{
		ptr =start;
		while (ptr->next != start)
			ptr= ptr->next;
		ptr->next = newnode;
		newnode->next = start;
	}
	fflush(stdin);
	printf("do you want to continue (y/n) ");
	scanf("%c",&ch);
  }while( ch =='y' || ch =='Y');
}


/* function to insert a node as a first node of circular linear linked list */
void insertf()
 {
	struct studinfo  *newnode,*ptr;
	newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
	printf("Enter a new  record : marks and name ");
	scanf("%d%s",&newnode->marks,newnode->name);

	if(start==NULL)
		{
			start = newnode;
			newnode->next = newnode;
		}
		else
		  {
		  ptr = start;
		  while(ptr->next !=start)
			  ptr = ptr->next;
		 newnode->next = start;
		  start = newnode;
		  ptr->next =start;
	  }
}
/* function to insert a node as a last node of circular linear linked list */
void insertl()
{
	struct studinfo *newnode, *ptr;
	newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
	printf("Enter a new  record : marks and name ");
	scanf("%d%s",&newnode->marks,newnode->name);
	if (start == NULL)
	{
		start =newnode;
		newnode->next = newnode;
	}
	else
	{
		ptr =start;
		while (ptr->next != start)
			ptr= ptr->next;
		ptr->next = newnode;
		newnode->next = start;
	}
} /* end of function */

/* function to insert a node after a given node in circular
 linear linked list */
void inserta()
  {
   int cnt=1, no;
	struct studinfo *ptr,*prevptr, *newnode;
	 printf("\n enter number ...");
	 scanf("%d",&no);
	 ptr=start;
	 while (cnt != no)
	 {
	 ptr = ptr->next;
	 cnt++;
	 }
	newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
	printf("Enter a new  record : marks and name");
	scanf("%d%s",&newnode->marks,newnode->name);
	newnode->next = ptr->next;
	ptr->next = newnode;
}

/* function to insert a node before a given node in circular
 linear linked list */
void insertb()
 {

	int cnt=1, no;
	struct studinfo *ptr,*prevptr, *newnode;
	 printf("\n enter number ...");
	 scanf("%d",&no);
	 ptr=start;
	if(no==1)
	 {
		insertf();
	 }
	 else
	 {
		while(cnt !=no)
		 {
			prevptr=ptr;
			ptr = ptr->next;
			cnt++;
		 }
		newnode=(struct studinfo *) malloc(sizeof(struct studinfo));
		printf("Enter a new  record : marks and name " );
		scanf("%d%s",&newnode->marks,newnode->name);
		newnode->next=ptr;
		prevptr->next=newnode;
	 }
}

/* function to delete the first node of circular linear linked list */
void deletef()
 {
   struct studinfo *ptrs,*ptr;
   ptrs=start;
   ptr = start;
   if (start == NULL)
		printf("\n List is empty, element can not be delete");
	else
   {
   if (ptr->next == start)
			start = NULL;
   else
   {
	   while(ptr->next !=start)
			  ptr = ptr->next;
	  start=start->next;
	  ptr->next = start;
   }
   free(ptrs);
  }
}
/* function to delete the last node of circular linear linked list */
 void deletel()
  {
	struct studinfo *ptr,*prevptr;
	ptr=start;
	if (start == NULL)
		printf("\n List is empty, element can not be delete");
	else
	{
	if (ptr->next == start)
		 start = NULL;
	else
	{
		while(ptr->next!=start)
		 {
			prevptr=ptr;
			ptr=ptr->next;
		 }
		 prevptr->next =start;
	}
	 free(ptr);
   }
}
/* function to delete a node by node number a given node in circular
 linear linked list */
void deleteno()
  {
	 int cnt=1,no;
	 struct studinfo *ptr,*prevptr, *newnode;
	 printf("\enter number ...");
	 scanf("%d",&no);
	 if (start == NULL)
		  printf( " List is empty,element can not be delete");
	 else
	 {
	 if((start->next==start)||(no ==1))
	 {
		deletef();
	 }
	else
	{
	ptr=start;

	while(cnt!=no)
		 {
			prevptr=ptr;
			ptr=ptr->next;
			cnt++;
		}
	if (ptr->next == start)
		 deletel();

	   prevptr->next=ptr->next;
	   free(ptr);
	}
   }
} /* End of function */


/* Function search find a record in the circular linear linked list */
void search()
{
	struct studinfo *ptr;
	char str[10];
	printf("enter name to be searched ");
	scanf("%s",str);
	ptr=start;
	while(ptr->next!=start)
	 {
		if(strcmp(ptr->name,str)==0)
		 {
			printf("\nfound");
			break;
		 }
		else
			ptr=ptr->next;
	 }
	if(ptr==NULL)
		printf("\nnot found");
	getch();
}

/* Function traverse traverse circular linear linked list */
void traverse()
{
	struct studinfo *ptr;
	ptr= start;
	if (ptr)
	{
		while (ptr->next !=start)
		{
			printf("\nRecord: marks and name %d  %s\n",ptr->marks, ptr->name);
			ptr = ptr->next;
		}
		if (ptr)
		   printf("\nRecord: marks and name %d  %s\n",ptr->marks, ptr->name);
	}
	else
		printf("\nCircular list is empty ");
	getch();
}
