/* Program cirqueue.cpp perform insertion, deletion operation on a circular
queue which is implmented using array in a queue structure . */

#include<stdio.h>
#include<conio.h>
#define MAXSIZE 5
struct queue{
	int items[MAXSIZE];
	int rear;
	int front;
}q;
void queueins(struct queue *,int);
int queuedel(struct queue *);
void display(struct queue *);

void queueins(struct queue *q,int x)
{
/* check for queue full if  front pointer at index 0 and rear pointer at
MAXSIZE -1. Or front is just behind rear i.e. front = rear +1 */
if (((q->front ==0) &&(q->rear==MAXSIZE -1))||(q->front ==q->rear+1))
 {
  printf("Queue full\n");
  display(q);
  return;
 }
else
{
 if (q->front == -1)
 { q->front =0; q->rear = 0;}
 else
   q->rear = (q->rear+1) % MAXSIZE;
 q->items[q->rear] = x;
}
} /* End of queueins function */


int queuedel(struct queue *q)
 {
 int x;
 /* check for queue empty when front pointer is at index -1. */
 if (q->front==-1)
	 printf(" Queue is empty\n");
 x = q->items[q->front];
 /* check for front equal to rear means queue is become empty and reinitiaze
 front and rear to -1. Otherwise front is increase by 1 in modulus way*/
 if (q->front == q->rear)
 { q->front = -1; q->rear =-1;}
 else
   q->front = (q->front +1) % MAXSIZE;
return x;
}

void display(struct queue *q)
 {
 int i;
 if (q->front != -1)
  if (q->front <= q->rear)
   for( i=q->front;i<=q->rear;i++)
	printf("%d      ",q->items[i]);
  else
  {
  for( i=q->front;i<MAXSIZE;i++)
   printf("%d      ",q->items[i]);
  for( i=0;i<=q->rear;i++)
   printf("%d      ",q->items[i]);
  }
} /* end of display function */


void main()
 {
	int ch,t;
	q.rear = -1;
	q.front = -1; /* Intially queue is empty */

	do{
	printf("\n Operations on Circular Queue [Maximum size of queue is 5]");
	printf(" \n 1. Insert \n 2. Delete\n 3. Display \n 4. Exit:\n");
	printf("\n Select operation ");
	scanf("%d",&ch);
	switch(ch)
	{
	 case 1:
		 printf("\nEnter data ");
		 scanf("%d",&t);
		 queueins(&q,t);
		 break;
	 case 2:
		 queuedel(&q);
		 break;
	 case 3:
		 display(&q);
		 break;
	 case 4:break;
	   }
  }while(ch<4);

} /* end of main */
