/* Program hashdh.c is insert keys into an array with double hashing
technique of collsion resolution technique. The maximum number of keys
can be insert is equal to MAXSIZE. The function hashdh insert the key
into hash value using two hash function h1(key) and h2(key)
of division method. */


#include<stdio.h>
#define MAXSIZE 10
int h[MAXSIZE];
void hashdh(int , int[]);
void hashdhsr(int key, int h[MAXSIZE]);
void display(int h[MAXSIZE]);
void main()
{
int i, key,ch ;
for(i=0;i<MAXSIZE;i++)
	h[i] = -1;
do{

	printf("\n\n Program for insertion/searching keys with double hashing ");
	printf("\n 1. Insert keys ");
	printf("\n 2. Search key ");
	printf("\n 3. Display keys ");
	printf("\n 4. Exit ");
	printf("\n Select operation ");
	scanf("%d",&ch);
	switch(ch)
	{
	case 1: do{
			printf("\n Enter key value [type -1 for termination] ");
			scanf("%d",&key);
			if (key != -1)

				hashdh(key,h);
			}while(key!=-1);
			break;
	case 2:	printf("\n Enter search key value ");
			scanf("%d",&key);
			hashdhsr(key,h);
			break;
	case 3: display(h);

		   break;
	}
	}while(ch!=4);
}

/* function hashdh find the location for a key and insert it */
void hashdh(int key, int h[MAXSIZE])
{
 int loc, i=0;
 loc = key % MAXSIZE;
 while (h[loc] !=-1)
	 loc = (loc + ++i*(key % (MAXSIZE -1))) % MAXSIZE;
 h[loc] = key;
 display(h);
} /* end of function */

/* function hashdhsr find the location for a key */
void hashdhsr(int key, int h[MAXSIZE])
{
 int loc,i=0;
 loc = key % MAXSIZE;
 while ((h[loc] != key) && (h[loc] !=-1))
	 loc = (loc + ++i*(key % (MAXSIZE -1))) % MAXSIZE;
 if (h[loc] != -1)
	printf("\n Search successful at index %d",loc);
 else
	printf("\n Search unsuccessful ");
} /* end of hashdhsr function */

void display(int h[MAXSIZE])
{
int i;
printf("\n List of keys, -1 indicate that the location is empty \n");
for (i=0;i<MAXSIZE;i++)
	printf(" %d ",h[i]);
}/* end of display function */