/* Program quick_re.c is recursive quicksort method to sort an array
of elements */
#include<conio.h>
#include<stdio.h>
#define MAXSIZE 20
void display(int x[],int n,int pivot)
{
int i;

for(i=0;i<n;i++)
{
	if(i==pivot)
		printf("< %d > ",x[i]);
	else
		printf("%d ",x[i]);

}
printf("\n\n");
}

int partition(int x[],int m,int p,int n)
/*
x[] if the file to be sorted. m denotes the file's lower bound
and p denotes its upper bound.
*/
{
int v=x[m],i=m,j=p,temp;
static pass;


while(i<j)
{
	while(x[i]<=v && i<p)
		i++;

	while(x[j]>v)
		j--;

	if(i<j)
	{
		temp=x[i];
		x[i]=x[j];
		x[j]=temp;
	}
}


x[m]=x[j];
x[j]=v;

printf(" Completion of Pass %d  ",++pass);
display(x,n,j);

return j;
}/* end of partition */

/* function quickr call recursively array until lower bound is smaller than
upper bound */
void quickr(int x[],int p,int q,int n)
{
int j;

if(p<q)
{
	j=partition(x,p,q,n);
	quickr(x,p,j-1,n);
	quickr(x,j+1,q,n);
}
}/* end of quickr */



void main()
{
int x[MAXSIZE],n,i;
clrscr();

printf("Enter the number of elements: ");
scanf("%d",&n);

printf("\nEnter the elements: \n");
for(i=0;i<n;i++)
scanf("%d",&x[i]);
printf("\n");

quickr(x,0,n-1,n);

printf("\nThe sorted output:\n");
for(i=0;i<n;i++)
printf("\n%d",x[i]);

getch();
}/* end of main */
