/* Program shelsort.c is shell sort the list of integer elements */
#include<stdio.h>
#define MAXSIZE 10
void shelsort (int x[], int n, int inc[], int nofinc)
{
	int i, j, k, span, temp;
	static int nc=0;
	for (i=0;i< nofinc; i++){
	/* span is the size of the increment */
	span = inc[i];
	for (j=span;j<n; j++){
	/* insert element x[j] into its proper within its subsets */
	nc++;
	temp = x[j];
	for (k=j-span; k>=0 && temp< x[k]; k=k-span)
		x[k+span]=x[k];

   x[k+span]=temp;
		}/*end of j inner for loop */
	}/* end of i outer for loop */
	printf("\n Number of comparisons required = %d", nc);
}/* end of shell sort */

void main()
{
	int x[MAXSIZE],n, i, nofinc,inc[MAXSIZE/2];
	printf("\n Enter number of elements ");
	scanf("%d",&n);
	printf("\n Unsorted list is as follows\n");

	for (i = 0; i < n; i++)
	{	printf("\n Enter element %d ",i+1);
		scanf("%d",&x[i]);
	}
	printf("\n Enter number of increments for shell sort[1-%d] ",n);
	scanf("%d",&nofinc);
	printf("\n Enter the incremetns value [%d -1] \n",n);

	for (i = 0; i < nofinc; i++)
	{	printf("\n Enter Increment %d ",i+1);
		scanf("%d",&inc[i]);
	}

	shelsort(x, n,inc,nofinc);
	printf("\n Sorted list is as follows\n");

	for (i = 0; i < n; i++)
		printf(" %d ", x[i]);

}

