/* The program fibstack.cpp is written in the form of non-recursive form using expliicit stack operations empty, pop ,and push. It finds the fibonacci term */

#include <stdio.h>
#include <stdlib.h>
#define MAXSIZE 80
#define TRUE 1
#define FALSE 0
int pop(struct stack *);
void push(struct stack *, int);
int empty(struct stack *);
int fibo(int n);
struct stack{
int top;
int items[MAXSIZE];
};

void main()
{
int n;
printf("\n Enter a Fibonacci term number ");
scanf("%d",&n);
printf("\n %d term of fibonacci sequence is %d",n, fibo(n-1));
} /* end main */

/*Recursive function fibo() is written in form of stack */
int fibo(int n)
{
int sum = 0;
struct stack s;
s.top = 0;
while (s.top>=0)
{
	if ((n ==0) || (n==1))
		   sum = sum + n;

	else if (n > 1)
	{
		push(&s, n-1);
		push(&s, n-2);
	}
	n = pop(&s);
 }
return(sum);
}

/* function push the integer element into stack s */
void push(struct stack *s, int d)
{
	if (s->top == MAXSIZE -1)
	{
		printf("%s", "stack overflow");
		exit(0);
	}
	else
		s->items[++(s->top)] = d;
	return;
} /* end of push function */

/* function pop the integer element from stack s */
int pop(struct stack *s)
{
	if (empty(s))
	{
		printf("\n%s", "stack underflow");
		exit(0);
	}
	return(s->items[s->top--]);
} /* end of pop function */

int empty(struct stack *s)
{
	if (s->top == -1)
	  return (TRUE);
	else
	 return (FALSE);
} /*end of empty function */

