/* Tower of Hanoi problem with implicit recursion*/
/* HANOI.Cpp */

# include<stdio.h>

void towers(char , char , char , int );

/* Definition of the Tower Of Hanoi generator function */

void towers(char needle1, char needle2, char  needle3, int n)
{
	if( n <= 0)
		printf("\n Illegal entry ");

	/*If only one disk, make the move and return */
	if(n == 1)
	{
		printf("\n Move Disk 1 from needle %c to needle %c", needle1, needle2);
		return;
	}
	/* Move top n -1 disks from A to B, using C as auxiliary */

		towers(needle1, needle3, needle2, n-1);
	/* Move remaining disk from A to C */
		printf("\n Move Disk %d from needle %c to needle %c",n, needle1, needle2);
	/* Move  n -1 disks from B to C, using A as auxiliary */
		towers(needle3, needle2, needle1, n-1);

} /* end of towers */

/* main function */

void main()
{
	int n;
	printf("\n Input the number of disc: ");
	scanf("%d", &n);
	printf("\n Tower of Hanoi for %d DISC", n);
	towers('A', 'C', 'B', n);
}
