/* recstack.cpp
 The function abc() is written in the form of non-recursive form
 using expliicit stack operations empty, pop ,and push */

#include <stdio.h>
#include <stdlib.h>
#define MAXSIZE 80
#define TRUE 1
#define FALSE 0
int pop(struct stack *);
void push(struct stack *, int);
int empty(struct stack *);
int abc(int n);
struct stack{
int top;
int items[MAXSIZE];
};

void main()
{
int n;
printf("\n Enter a number ");
scanf("%d",&n);
printf("\n Result is %d", abc(n));
} /* end main */

/*Recursive function abc() is written in form of stack */
int abc(int n)
{
int sum = 0;
struct stack s;
s.top = 0;
while (s.top>=0)
{

	if (n > 0)
	{
		push(&s, n-1);
		push(&s, n-2);
	}
	if (n<=0)
		 sum = sum + 1;
	n = pop(&s);
 }
return(sum);
}

/* function push the integer element into stack s */
void push(struct stack *s, int d)
{
	if (s->top == MAXSIZE -1)
	{
		printf("%s", "stack overflow");
		exit(0);
	}
	else
		s->items[++(s->top)] = d;
	return;
} /* end of push function */

/* function pop the integer element from stack s */
int pop(struct stack *s)
{
	if (empty(s))
	{
		printf("\n%s", "stack underflow");
		exit(0);
	}
	return(s->items[s->top--]);
} /* end of pop function */

int empty(struct stack *s)
{
	if (s->top == -1)
	  return (TRUE);
	else
	 return (FALSE);
} /*end of empty function */

