
/* This program insert nodes, delete nodes in binary search tree */
/* BTREEDEL.cpp */

# include<stdio.h>
# include<malloc.h>
# include<conio.h>
struct nodetype
{
	int info;
	struct nodetype *lchild;
	struct nodetype *rchild;
}*root, *dnode, *pardnode; ;
void btreeins(int);
void btsrch(int);
void delcaseA(struct nodetype *,struct nodetype *);
void delcaseB();
void btreedel(int);
void  display(struct nodetype *, int);

void main()
{
int dn;
clrscr();
root = NULL;
dnode = NULL;
pardnode = NULL;
btreeins(20);
btreeins(10);
btreeins(12);
btreeins(15);
btreeins(24);
btreeins(5);
btreeins(4);


btreeins(12);
printf("\n Binary Search Tree with Root is %d as Follows", root->info);
display(root,1);
printf("\npl enter the node to be delete ");
scanf("%d",&dn);
btreedel(dn);
printf("\n Binary Search Tree after Deletion of node %d is as follows",dn);
display(root,1);
}/* end of main function */

/* The funstion btreeins insert the nodes in bst */
void btreeins(int x)
{
struct nodetype *p, *parent;
int found =0;
p = root;
while((p!=NULL) &&(!found))
{
 parent = p;
 if (x == p->info)
	found = 1;
 else if (x < p->info )
	p = p->lchild;
 else
	p = p->rchild;
}
if (!found)
{
p = (struct nodetype *)malloc(sizeof(struct nodetype));
p->info =x;
p->lchild =NULL;
p->rchild =NULL;

if (root!=NULL)
	{
	if ( x<parent->info)
		parent->lchild =p;
	else
		parent->rchild =p;
	}
else
	root = p;
}
} /* End of function btreeins */

/* The function btreedel delete a node from binary search tree */
void btreedel(int x)
{
btsrch(x);
if(dnode==NULL)
	{
	printf("\n not found");
	return;
	}
if ((dnode->rchild !=NULL) && (dnode->lchild!=NULL))
	delcaseB();
else
   delcaseA(dnode, pardnode);
free(dnode);
} /* End of function btreedel */

/* The btsrch function search a node in the Binary Search Tree */
void btsrch(int x)
{
dnode =root;
 while((dnode!=NULL) &&(dnode->info !=x))
 {
 pardnode = dnode;
 if (dnode->info >x)
	dnode = dnode->lchild;
 else
	 dnode = dnode->rchild;
 }
} /* End of function btsrch */

/* The delcaseA function deletes the node with one child or as leaf node */
void delcaseA(struct nodetype *dnode,struct nodetype *pardnode)
{
struct nodetype *child;
if ((dnode->lchild ==NULL) &&(dnode->rchild==NULL))
	child = NULL;
else if ((dnode->lchild)!=NULL)
		child = dnode->lchild;
	else
		child = dnode->rchild;
if (pardnode !=NULL)
	if (dnode==pardnode->lchild)
			pardnode->lchild = child;
	else
		pardnode->rchild = child;
else
		root = child;
}/* End of delcaseA function */

/* The delcaseB function deletes the node with two child  */
void delcaseB()
{
struct nodetype *p,*q, *succ, *parsucc;
p = dnode->rchild;
q = dnode;
while ((p->lchild) !=NULL)
{
	q = p;
	p = p->lchild;
}
succ = p;
parsucc = q;
delcaseA(succ, parsucc);

if (pardnode !=NULL)
	if (dnode == pardnode->lchild)
		pardnode->lchild = succ;
	else
	pardnode->rchild = succ;
else
	root = succ;
succ->lchild = dnode->lchild;
succ->rchild = dnode->rchild;
}/* End of delcaseB function */

void display(struct nodetype *start, int t)
{
int i=1;
struct nodetype *ptr=start;
if (ptr)
{
display (ptr->rchild,t+1);
printf("\n");
for(i=0;i<=t;i++)
	printf("   ");
printf("%d< ",ptr->info);
display (ptr->lchild, t+1);
}
}
